Index: trunk/NEMO/OPA_SRC/DYN/dynhpg.F90
===================================================================
--- trunk/NEMO/OPA_SRC/DYN/dynhpg.F90	(revision 485)
+++ trunk/NEMO/OPA_SRC/DYN/dynhpg.F90	(revision 503)
@@ -4,4 +4,14 @@
    !! Ocean dynamics:  hydrostatic pressure gradient trend
    !!======================================================================
+   !! History :  1.0  !  87-09  (P. Andrich, M.-A. Foujols)  hpg_zco: Original code
+   !!            5.0  !  91-11  (G. Madec)
+   !!            7.0  !  96-01  (G. Madec)  hpg_sco: Original code for s-coordinates
+   !!            8.0  !  97-05  (G. Madec)  split dynber into dynkeg and dynhpg
+   !!            8.5  !  02-07  (G. Madec)  F90: Free form and module
+   !!            8.5  !  02-08  (A. Bozec)  hpg_zps: Original code
+   !!            9.0  !  05-10  (A. Beckmann, B.W. An)  various s-coordinate options
+   !!                           Original code for hpg_ctl, hpg_hel hpg_wdj, hpg_djc, hpg_rot 
+   !!            9.0  !  05-11  (G. Madec) style & small optimisation
+   !!----------------------------------------------------------------------
 
    !!----------------------------------------------------------------------
@@ -18,5 +28,4 @@
    !!       hpg_rot  : s-coordinate (ROTated axes scheme)
    !!----------------------------------------------------------------------
-   !! * Modules used
    USE oce             ! ocean dynamics and tracers
    USE dom_oce         ! ocean space and time domain
@@ -32,6 +41,5 @@
    PRIVATE
 
-   !! * Accessibility
-   PUBLIC dyn_hpg                ! routine called by step.F90
+   PUBLIC   dyn_hpg    ! routine called by step module
 
 #if defined key_mpp_omp
@@ -49,20 +57,18 @@
 #endif
 
-   !! * Share module variables
-   LOGICAL  ::               & !!! ** nam_dynhpg **   hpg flags
-      ln_hpg_zco = .TRUE. ,  &  ! z-coordinate - full steps
-      ln_hpg_zps = .FALSE.,  &  ! z-coordinate - partial steps (interpolation)
-      ln_hpg_sco = .FALSE.,  &  ! s-coordinate (standard jacobian formulation)
-      ln_hpg_hel = .FALSE.,  &  ! s-coordinate (helsinki modification)
-      ln_hpg_wdj = .FALSE.,  &  ! s-coordinate (weighted density jacobian)
-      ln_hpg_djc = .FALSE.,  &  ! s-coordinate (Density Jacobian with Cubic polynomial)
-      ln_hpg_rot = .FALSE.      ! s-coordinate (ROTated axes scheme)
-
-   REAL(wp) ::               & !!! ** nam_dynhpg ** 
-      gamm = 0.e0               ! weighting coefficient
-
-   INTEGER  ::               &  ! 
-      nhpg  =  0                 ! = 0 to 6, type of pressure gradient scheme used
-      !                         ! (deduced from ln_hpg_... flags)
+   !!* Namelist nam_dynhpg : Choice of horizontal pressure gradient computation
+   LOGICAL  ::   ln_hpg_zco = .TRUE.    ! z-coordinate - full steps
+   LOGICAL  ::   ln_hpg_zps = .FALSE.   ! z-coordinate - partial steps (interpolation)
+   LOGICAL  ::   ln_hpg_sco = .FALSE.   ! s-coordinate (standard jacobian formulation)
+   LOGICAL  ::   ln_hpg_hel = .FALSE.   ! s-coordinate (helsinki modification)
+   LOGICAL  ::   ln_hpg_wdj = .FALSE.   ! s-coordinate (weighted density jacobian)
+   LOGICAL  ::   ln_hpg_djc = .FALSE.   ! s-coordinate (Density Jacobian with Cubic polynomial)
+   LOGICAL  ::   ln_hpg_rot = .FALSE.   ! s-coordinate (ROTated axes scheme)
+   REAL(wp) ::   gamm       = 0.e0      ! weighting coefficient
+   NAMELIST/nam_dynhpg/ ln_hpg_zco, ln_hpg_zps, ln_hpg_sco, ln_hpg_hel,   &
+      &                 ln_hpg_wdj, ln_hpg_djc, ln_hpg_rot, gamm
+
+   INTEGER  ::   nhpg  =  0             ! = 0 to 6, type of pressure gradient scheme used
+      !                                 ! (deduced from ln_hpg_... flags)
 
    !! * Substitutions
@@ -72,5 +78,5 @@
    !!   OPA 9.0 , LOCEAN-IPSL (2005) 
    !! $Header$ 
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
+   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
@@ -82,25 +88,17 @@
       !!
       !! ** Method  :   Call the hydrostatic pressure gradient routine 
-      !!      using the scheme defined in the namelist (nhpg parameter)
+      !!              using the scheme defined in the namelist
       !!   
       !! ** Action : - Update (ua,va) with the now hydrastatic pressure trend
       !!             - Save the trend (l_trddyn=T)
-      !!             - Control print  (ln_ctl)
-      !!
-      !! History :
-      !!   9.0  !  05-10  (A. Beckmann, G. Madec) various s-coordinate options
-      !!----------------------------------------------------------------------
-      !! * Arguments
-      INTEGER, INTENT( in ) ::   kt     ! ocean time-step index
-
-      !! * local declarations
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   &
-         ztrdu, ztrdv                         ! 3D temporary workspace
+      !!----------------------------------------------------------------------
+      INTEGER, INTENT(in) ::   kt   ! ocean time-step index
+      !!
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   ztrdu, ztrdv   ! 3D temporary workspace
       !!----------------------------------------------------------------------
    
       IF( kt == nit000 )   CALL hpg_ctl      ! initialisation & control of options
 
-      ! Temporary saving of ua and va trends (l_trddyn)
-      IF( l_trddyn )   THEN
+      IF( l_trddyn ) THEN                    ! Temporary saving of ua and va trends (l_trddyn)
          ztrdu(:,:,:) = ua(:,:,:)  
          ztrdv(:,:,:) = va(:,:,:) 
@@ -108,38 +106,25 @@
 
       SELECT CASE ( nhpg )      ! Hydrastatic pressure gradient computation
-      CASE ( 0 )                  ! z-coordinate 
-         CALL hpg_zco( kt )
-      CASE ( 1 )                  ! z-coordinate plus partial steps (interpolation)
-         CALL hpg_zps( kt )
-      CASE ( 2 )                  ! s-coordinate (standard jacobian formulation)
-         CALL hpg_sco( kt )
-      CASE ( 3 )                  ! s-coordinate (helsinki modification)
-         CALL hpg_hel( kt )
-      CASE ( 4 )                  ! s-coordinate (weighted density jacobian)
-         CALL hpg_wdj( kt )
-      CASE ( 5 )                  ! s-coordinate (Density Jacobian with Cubic polynomial)
-         CALL hpg_djc( kt )
-      CASE ( 6 )                  ! s-coordinate (ROTated axes scheme)
-         CALL hpg_rot( kt )
-      CASE ( 10 )                  ! z-coordinate
-         CALL hpg_zco_jki( kt )
-      CASE ( 11 )                  ! z-coordinate plus partial steps (interpolation)
-         CALL hpg_zps_jki( kt )
-      CASE ( 12 )                  ! s-coordinate (standard jacobian formulation)
-         CALL hpg_sco_jki( kt )
+      CASE (  0 )   ;   CALL hpg_zco    ( kt )      ! z-coordinate
+      CASE (  1 )   ;   CALL hpg_zps    ( kt )      ! z-coordinate plus partial steps (interpolation)
+      CASE (  2 )   ;   CALL hpg_sco    ( kt )      ! s-coordinate (standard jacobian formulation)
+      CASE (  3 )   ;   CALL hpg_hel    ( kt )      ! s-coordinate (helsinki modification)
+      CASE (  4 )   ;   CALL hpg_wdj    ( kt )      ! s-coordinate (weighted density jacobian)
+      CASE (  5 )   ;   CALL hpg_djc    ( kt )      ! s-coordinate (Density Jacobian with Cubic polynomial)
+      CASE (  6 )   ;   CALL hpg_rot    ( kt )      ! s-coordinate (ROTated axes scheme)
+      CASE ( 10 )   ;   CALL hpg_zco_jki( kt )      ! z-coordinate (k-j-i)
+      CASE ( 11 )   ;   CALL hpg_zps_jki( kt )      ! z-coordinate plus partial steps (interpolation) (k-j-i)
+      CASE ( 12 )   ;   CALL hpg_sco_jki( kt )      ! s-coordinate (standard jacobian formulation) (k-j-i)
       END SELECT
 
-      ! save the hydrostatic pressure gradient trends for momentum trend diagnostics
-      IF( l_trddyn )   THEN
+      IF( l_trddyn ) THEN      ! save the hydrostatic pressure gradient trends for momentum trend diagnostics
          ztrdu(:,:,:) = ua(:,:,:) - ztrdu(:,:,:)
          ztrdv(:,:,:) = va(:,:,:) - ztrdv(:,:,:)
-         CALL trd_mod( ztrdu, ztrdv, jpdtdhpg, 'DYN', kt )
+         CALL trd_mod( ztrdu, ztrdv, jpdyn_trd_hpg, 'DYN', kt )
       ENDIF          
-      
-      IF(ln_ctl) THEN         ! print sum trends (used for debugging)
-         CALL prt_ctl( tab3d_1=ua, clinfo1=' hpg  - Ua: ', mask1=umask, &
-            &          tab3d_2=va, clinfo2=       ' Va: ', mask2=vmask, clinfo3='dyn' )
-      ENDIF
-      
+      !
+      IF(ln_ctl)   CALL prt_ctl( tab3d_1=ua, clinfo1=' hpg  - Ua: ', mask1=umask,   &
+         &                       tab3d_2=va, clinfo2=       ' Va: ', mask2=vmask, clinfo3='dyn' )
+      !
    END SUBROUTINE dyn_hpg
 
@@ -154,21 +139,12 @@
       !! ** Action  :   Read the namelist namdynhpg and check the consistency
       !!      with the type of vertical coordinate used (zco, zps, sco)
-      !!
-      !! History :
-      !!   9.0  !  05-10  (A. Beckmann)  Original code
       !!----------------------------------------------------------------------
       INTEGER ::   ioptio = 0      ! temporary integer
-
-      NAMELIST/nam_dynhpg/ ln_hpg_zco, ln_hpg_zps, ln_hpg_sco,               &
-         &                 ln_hpg_hel, ln_hpg_wdj, ln_hpg_djc, ln_hpg_rot,   &
-         &                 gamm
-      !!----------------------------------------------------------------------
-
-      ! Read Namelist nam_dynhpg : pressure gradient calculation options
-      REWIND ( numnam )
+      !!----------------------------------------------------------------------
+
+      REWIND ( numnam )               ! Read Namelist nam_dynhpg : pressure gradient calculation options
       READ   ( numnam, nam_dynhpg )
 
-      ! Control print
-      IF(lwp) THEN
+      IF(lwp) THEN                    ! Control print
          WRITE(numout,*)
          WRITE(numout,*) 'dyn:hpg_ctl : hydrostatic pressure gradient control'
@@ -185,5 +161,5 @@
       ENDIF
 
-      ! set nhpg from ln_hpg_... flags
+      !                               ! Set nhpg from ln_hpg_... flags
       IF( ln_hpg_zco )   nhpg = 0
       IF( ln_hpg_zps )   nhpg = 1
@@ -194,5 +170,5 @@
       IF( ln_hpg_rot )   nhpg = 6
 
-      ! Consitency check
+      !                               ! Consitency check
       ioptio = 0 
       IF( ln_hpg_zco )   ioptio = ioptio + 1
@@ -203,6 +179,5 @@
       IF( ln_hpg_djc )   ioptio = ioptio + 1
       IF( ln_hpg_rot )   ioptio = ioptio + 1
-      IF ( ioptio > 1 )   &
-           &   CALL ctl_stop( ' several hydrostatic pressure gradient options used' )
+      IF ( ioptio /= 1 )   CALL ctl_stop( ' NO or several hydrostatic pressure gradient options used' )
 
       IF( lk_dynhpg_jki ) THEN
@@ -211,5 +186,5 @@
          IF(lwp) WRITE(numout,*) '          Autotasking or OPENMP: use j-k-i loops (i.e. _jki routines)'
       ENDIF
-
+      !
    END SUBROUTINE hpg_ctl
 
@@ -230,23 +205,12 @@
       !! 
       !! ** Action : - Update (ua,va) with the now hydrastatic pressure trend
-      !!
-      !! History :
-      !!   1.0  !  87-09  (P. Andrich, M.-A. Foujols)  Original code
-      !!   5.0  !  91-11  (G. Madec)
-      !!   7.0  !  96-01  (G. Madec)
-      !!   8.0  !  97-05  (G. Madec)  split dynber into dynkeg and dynhpg
-      !!   8.5  !  02-07  (G. Madec)  F90: Free form and module
-      !!----------------------------------------------------------------------
-      !! * modules used
-      USE oce, ONLY :   zhpi => ta,  &  ! use ta as 3D workspace
-         &              zhpj => sa      ! use sa as 3D workspace
-      
-      !! * Arguments
-      INTEGER, INTENT( in ) ::   kt     ! ocean time-step index
-      
-      !! * local declarations
-      INTEGER ::   ji, jj, jk           ! dummy loop indices
-      REAL(wp) ::   &   
-         zcoef0, zcoef1                 ! temporary scalars
+      !!----------------------------------------------------------------------
+      USE oce, ONLY :   zhpi => ta   ! use ta as 3D workspace
+      USE oce, ONLY :   zhpj => sa   ! use sa as 3D workspace
+      !!
+      INTEGER, INTENT(in) ::   kt    ! ocean time-step index
+      !!
+      INTEGER  ::   ji, jj, jk       ! dummy loop indices
+      REAL(wp) ::   zcoef0, zcoef1   ! temporary scalars
       !!----------------------------------------------------------------------
       
@@ -257,11 +221,8 @@
       ENDIF
       
-      
       ! Local constant initialization 
-      ! -----------------------------
       zcoef0 = - grav * 0.5
 
       ! Surface value
-      ! -------------
       DO jj = 2, jpjm1
          DO ji = fs_2, fs_jpim1   ! vector opt.
@@ -275,7 +236,6 @@
          END DO
       END DO
-
+      !
       ! interior value (2=<jk=<jpkm1)
-      ! --------------
       DO jk = 2, jpkm1
          DO jj = 2, jpjm1
@@ -296,5 +256,5 @@
          END DO
       END DO
-
+      !
    END SUBROUTINE hpg_zco
 
@@ -307,22 +267,13 @@
       !! 
       !! ** Action  : - Update (ua,va) with the now hydrastatic pressure trend
-      !!    
-      !! History :
-      !!   8.5  !  02-08  (A. Bozec)  Original code
-      !!   9.0  !  04-08  (G. Madec)  F90
       !!---------------------------------------------------------------------- 
-      !! * modules used                                 
-      USE oce, ONLY :   zhpi => ta,  &  ! use ta as 3D workspace
-         &              zhpj => sa      ! use sa as 3D workspace
-               
-      !! * Arguments
-      INTEGER, INTENT( in ) ::   kt     ! ocean time-step index
-
-      !! * local declarations
-      INTEGER ::   ji, jj, jk           ! dummy loop indices
-      INTEGER ::   iku, ikv             ! temporary integers
-      REAL(wp) ::   &
-         zcoef0, zcoef1,             &  ! temporary scalars
-         zcoef2, zcoef3                 !    "         "
+      USE oce, ONLY :   zhpi => ta   ! use ta as 3D workspace
+      USE oce, ONLY :   zhpj => sa   ! use sa as 3D workspace
+      !!
+      INTEGER, INTENT(in) ::   kt    ! ocean time-step index
+      !!
+      INTEGER  ::   ji, jj, jk                       ! dummy loop indices
+      INTEGER  ::   iku, ikv                         ! temporary integers
+      REAL(wp) ::   zcoef0, zcoef1, zcoef2, zcoef3   ! temporary scalars
       !!----------------------------------------------------------------------
 
@@ -330,15 +281,11 @@
          IF(lwp) WRITE(numout,*)
          IF(lwp) WRITE(numout,*) 'dyn:hpg_zps : hydrostatic pressure gradient trend'
-         IF(lwp) WRITE(numout,*) '~~~~~~~~~~~   z-coordinate with partial steps'
-         IF(lwp) WRITE(numout,*) '              vector optimization'
+         IF(lwp) WRITE(numout,*) '~~~~~~~~~~~   z-coordinate with partial steps - vector optimization'
       ENDIF
 
-
-      ! 0. Local constant initialization
-      ! --------------------------------
+      ! Local constant initialization
       zcoef0 = - grav * 0.5
 
-      ! 1. Surface value
-      ! ----------------
+      !  Surface value
       DO jj = 2, jpjm1
          DO ji = fs_2, fs_jpim1   ! vector opt.
@@ -353,6 +300,5 @@
       END DO
 
-      ! 2. interior value (2=<jk=<jpkm1)
-      ! -----------------
+      ! interior value (2=<jk=<jpkm1)
       DO jk = 2, jpkm1
          DO jj = 2, jpjm1
@@ -410,5 +356,5 @@
 # endif
       END DO
-
+      !
    END SUBROUTINE hpg_zps
 
@@ -431,23 +377,12 @@
       !!
       !! ** Action : - Update (ua,va) with the now hydrastatic pressure trend
-      !!
-      !! History :
-      !!   7.0  !  96-01  (G. Madec)  s-coordinates
-      !!        !  97-05  (G. Madec)  split dynber into dynkeg and dynhpg
-      !!   8.5  !  02-08  (G. Madec)  F90: Free form and module, vector opt.
-      !!   9.0  !  04-08  (C. Talandier) New trends organization
-      !!   9.0  !  05-10  (A. Beckmann) various s-coordinate options
-      !!----------------------------------------------------------------------
-      !! * modules used
-      USE oce, ONLY :   zhpi => ta,  &  ! use ta as 3D workspace
-         &              zhpj => sa      ! use sa as 3D workspace
-
-      !! * Arguments
-      INTEGER, INTENT( in ) ::   kt     ! ocean time-step index
-
-      !! * Local declarations
-      INTEGER ::   ji, jj, jk           ! dummy loop indices
-      REAL(wp) ::   &
-         zcoef0, zuap, zvap             ! temporary scalars
+      !!----------------------------------------------------------------------
+      USE oce, ONLY :   zhpi => ta   ! use ta as 3D workspace
+      USE oce, ONLY :   zhpj => sa   ! use sa as 3D workspace
+      !!
+      INTEGER, INTENT(in) ::   kt    ! ocean time-step index
+      !!
+      INTEGER  ::   ji, jj, jk           ! dummy loop indices
+      REAL(wp) ::   zcoef0, zuap, zvap   ! temporary scalars
       !!----------------------------------------------------------------------
 
@@ -458,12 +393,8 @@
       ENDIF
 
-
-      ! 0. Local constant initialization
-      ! --------------------------------
+      ! Local constant initialization
       zcoef0 = - grav * 0.5
 
-
-      ! 1. Surface value
-      ! ----------------                          
+      ! Surface value
       DO jj = 2, jpjm1
          DO ji = fs_2, fs_jpim1   ! vector opt.   
@@ -484,7 +415,5 @@
       END DO   
             
-               
-      ! 2. interior value (2=<jk=<jpkm1)
-      ! -----------------     
+      ! interior value (2=<jk=<jpkm1)
       DO jk = 2, jpkm1                                  
          DO jj = 2, jpjm1     
@@ -508,5 +437,5 @@
          END DO
       END DO
-
+      !
    END SUBROUTINE hpg_sco
 
@@ -530,19 +459,12 @@
       !! ** Action : - Update (ua,va) with the now hydrastatic pressure trend
       !!             - Save the trend (l_trddyn=T)
-      !!
-      !! History :
-      !!   9.0  !  05-10  (A. Beckmann)  Original code
-      !!----------------------------------------------------------------------
-      !! * modules used
-      USE oce, ONLY :   zhpi => ta,  &  ! use ta as 3D workspace
-         &              zhpj => sa      ! use sa as 3D workspace
-
-      !! * Arguments
-      INTEGER, INTENT( in ) ::   kt     ! ocean time-step index
-      
-      !! * Local declarations
-      INTEGER ::   ji, jj, jk           ! dummy loop indices
-      REAL(wp) ::   &
-         zcoef0, zuap, zvap             ! temporary scalars
+      !!----------------------------------------------------------------------
+      USE oce, ONLY :   zhpi => ta   ! use ta as 3D workspace
+      USE oce, ONLY :   zhpj => sa   ! use sa as 3D workspace
+      !!
+      INTEGER, INTENT(in) ::   kt    ! ocean time-step index
+      !!
+      INTEGER  ::   ji, jj, jk           ! dummy loop indices
+      REAL(wp) ::   zcoef0, zuap, zvap   ! temporary scalars
       !!----------------------------------------------------------------------
 
@@ -553,12 +475,8 @@
       ENDIF
 
-
-      ! 0. Local constant initialization
-      ! --------------------------------
+      ! Local constant initialization
       zcoef0 = - grav * 0.5
-
  
-      ! 1. Surface value
-      ! ----------------
+      ! Surface value
       DO jj = 2, jpjm1
          DO ji = fs_2, fs_jpim1   ! vector opt.
@@ -578,7 +496,6 @@
          END DO
       END DO
-
-      ! 2. interior value (2=<jk=<jpkm1)
-      ! -----------------
+      !
+      ! interior value (2=<jk=<jpkm1)
       DO jk = 2, jpkm1
          DO jj = 2, jpjm1
@@ -606,5 +523,5 @@
          END DO
       END DO
-
+      !
    END SUBROUTINE hpg_hel
 
@@ -619,21 +536,13 @@
       !!
       !! Reference : Song, Mon. Wea. Rev., 126, 3213-3230, 1998.
-      !!
-      !! History :
-      !!   9.0  !  05-05  (B.W. An)  Original code
-      !!        !  05-10  (G. Madec) style & small optimisation
-      !!----------------------------------------------------------------------
-      !! * modules used
-      USE oce, ONLY :   zhpi => ta,  &  ! use ta as 3D workspace
-         &              zhpj => sa      ! use sa as 3D workspace
-
-      !! * Arguments
-      INTEGER, INTENT( in ) ::   kt     ! ocean time-step index
-
-      !! * Local declarations
-      INTEGER ::   ji, jj, jk           ! dummy loop indices
-      REAL(wp) ::   &
-         zcoef0, zuap, zvap,         &  ! temporary scalars
-         zalph , zbeta                  !    "         "
+      !!----------------------------------------------------------------------
+      USE oce, ONLY :   zhpi => ta   ! use ta as 3D workspace
+      USE oce, ONLY :   zhpj => sa   ! use sa as 3D workspace
+      !!
+      INTEGER, INTENT(in) ::   kt    ! ocean time-step index
+      !!
+      INTEGER  ::   ji, jj, jk           ! dummy loop indices
+      REAL(wp) ::   zcoef0, zuap, zvap   ! temporary scalars
+      REAL(wp) ::   zalph , zbeta        !    "         "
       !!----------------------------------------------------------------------
 
@@ -644,7 +553,5 @@
       ENDIF
 
-
       ! Local constant initialization
-      ! -----------------------------
       zcoef0 = - grav * 0.5
       zalph  = 0.5 - gamm        ! weighting coefficients (alpha=0.5-gamm)
@@ -652,5 +559,4 @@
 
       ! Surface value (no ponderation)
-      ! -------------
       DO jj = 2, jpjm1
          DO ji = fs_2, fs_jpim1   ! vector opt.
@@ -672,5 +578,4 @@
 
       ! Interior value (2=<jk=<jpkm1) (weighted with zalph & zbeta)
-      ! --------------
       DO jk = 2, jpkm1
          DO jj = 2, jpjm1
@@ -700,5 +605,5 @@
          END DO
       END DO
-
+      !
    END SUBROUTINE hpg_wdj
 
@@ -710,26 +615,18 @@
       !! ** Method  :   Density Jacobian with Cubic polynomial scheme
       !! 
-      !! Reference: Shchepetkin, A.F. & J.C. McWilliams, J. Geophys. Res.,
-      !!            108(C3), 3090, 2003
-      !! History :
-      !!   9.0  !  05-05  (B.W. An)  Original code
-      !!----------------------------------------------------------------------
-      !! * modules used
-      USE oce, ONLY :   zhpi => ta,  &  ! use ta as 3D workspace
-         &              zhpj => sa      ! use sa as 3D workspace
-
-      !! * Arguments
-      INTEGER, INTENT( in ) ::   kt     ! ocean time-step index
-      
-      !! * Local declarations
-      INTEGER ::   ji, jj, jk           ! dummy loop indices
-      REAL(wp) ::   &
-         zcoef0, z1_10, cffu, cffx,  &  ! temporary scalars
-                 z1_12, cffv, cffy,  &  !    "         "
-         zep   , cffw                   !    "         "
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   &  ! 3D workspace
-         drhox, dzx, drhou, dzu, rho_i,     &
-         drhoy, dzy, drhov, dzv, rho_j,     &
-         drhoz, dzz, drhow, dzw, rho_k
+      !! Reference: Shchepetkin and McWilliams, J. Geophys. Res., 108(C3), 3090, 2003
+      !!----------------------------------------------------------------------
+      USE oce, ONLY :   zhpi => ta   ! use ta as 3D workspace
+      USE oce, ONLY :   zhpj => sa   ! use sa as 3D workspace
+      !!
+      INTEGER, INTENT(in) ::   kt    ! ocean time-step index
+      !!
+      INTEGER  ::   ji, jj, jk          ! dummy loop indices
+      REAL(wp) ::   zcoef0, zep, cffw   ! temporary scalars
+      REAL(wp) ::   z1_10, cffu, cffx   !    "         "
+      REAL(wp) ::   z1_12, cffv, cffy   !    "         "
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   drhox, dzx, drhou, dzu, rho_i   ! 3D workspace
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   drhoy, dzy, drhov, dzv, rho_j   !  "      "
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   drhoz, dzz, drhow, dzw, rho_k   !  "      "
       !!----------------------------------------------------------------------
 
@@ -741,6 +638,5 @@
 
 
-      ! 0. Local constant initialization
-      ! --------------------------------
+      ! Local constant initialization
       zcoef0 = - grav * 0.5
       z1_10  = 1.0 / 10.0
@@ -771,6 +667,6 @@
       zep = 1.e-15
 
-      !!bug  gm  drhoz not defined at level 1 and used (jk-1 with jk=2)
-      !!bug  gm  idem for drhox, drhoy et ji=jpi and jj=jpj
+!!bug  gm  drhoz not defined at level 1 and used (jk-1 with jk=2)
+!!bug  gm  idem for drhox, drhoy et ji=jpi and jj=jpj
 
       DO jk = 2, jpkm1
@@ -930,5 +826,5 @@
          END DO
       END DO
-
+      !
    END SUBROUTINE hpg_djc
 
@@ -941,25 +837,16 @@
       !!
       !! Reference: Thiem & Berntsen, Ocean Modelling, In press, 2005.
-      !! History :
-      !!   9.0  !  05-07 (B.W. An)
-      !!   9.0  !  05-10 (A. Beckmann) adapted to non-equidistant and masked grids
-      !!----------------------------------------------------------------------
-      !! * modules used
-      USE oce, ONLY :   zhpi => ta,         &  ! use ta as 3D workspace
-         &              zhpj => sa             ! use sa as 3D workspace
-
-      !! * Arguments
-      INTEGER, INTENT( in ) ::   kt            ! ocean time-step index
-      
-      !! * Local declarations
-      INTEGER ::   ji, jj, jk                  ! dummy loop indices
-      REAL(wp) ::   &
-         zforg, zcoef0, zuap, zmskd1, zmskd1m,                             &
-         zfrot        , zvap, zmskd2, zmskd2m
-      REAL(wp), DIMENSION(jpi,jpj) ::       &  ! 2D temporary workspace
-         zdistr, zsina, zcosa             
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   &  ! 3D temporary workspace
-         zhpiorg, zhpirot, zhpitra, zhpine, & 
-         zhpjorg, zhpjrot, zhpjtra, zhpjne
+      !!----------------------------------------------------------------------
+      USE oce, ONLY :   zhpi => ta   ! use ta as 3D workspace
+      USE oce, ONLY :   zhpj => sa   ! use sa as 3D workspace
+      !!
+      INTEGER, INTENT(in) ::   kt    ! ocean time-step index
+      !!
+      INTEGER  ::   ji, jj, jk          ! dummy loop indices
+      REAL(wp) ::   zforg, zcoef0, zuap, zmskd1, zmskd1m   ! temporary scalar
+      REAL(wp) ::   zfrot        , zvap, zmskd2, zmskd2m   !    "         "
+      REAL(wp), DIMENSION(jpi,jpj)     ::   zdistr, zsina, zcosa                ! 2D workspace
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zhpiorg, zhpirot, zhpitra, zhpine   ! 3D workspace
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zhpjorg, zhpjrot, zhpjtra, zhpjne   !  "      "
       !!----------------------------------------------------------------------
 
@@ -1118,5 +1005,5 @@
          END DO
       END DO
-
+      !
    END SUBROUTINE hpg_rot
 
